
InfamyCardGui.WHITEISH_CARD_COLOR = Color(227, 277, 209) / 255

InfamyCardGui.CUSTOM_CARD_FOLDER = "custom_cards"
InfamyCardGui.CUSTOM_CARD_FOLDER_RANDOM = "custom_cards/random"
InfamyCardGui.CUSTOM_CARD_PREFIX = "infamy"

InfamyCardGui.SUPPORTED_EXTENTIONS = {".movie", ".dds", ".tga"}

InfamyCardGui._PICK_RANDOM_CARD = InfCrdPic_MOD.Options:GetValue("icp_pick_settings/icp_random_card")
InfamyCardGui._SHOW_INFAMY_RANK = InfCrdPic_MOD.Options:GetValue("icp_pick_settings/icp_rank_card")
InfamyCardGui._SHOW_INFAMY_RANK_TEXT = InfCrdPic_MOD.Options:GetValue("icp_pick_settings/icp_ranktext_card")
InfamyCardGui._DISABLE_GLOW = InfCrdPic_MOD.Options:GetValue("icp_pick_settings/icp_no_glow_card")


function InfamyCardGui:show_rank(rank)
	self:clear_gui()
	
	local original_rank = rank
	local ingame_path
	local card_full_mod_path
	local card_full_mod_extension = ""
	
	if InfamyCardGui._PICK_RANDOM_CARD then
		-- "assets/mod_overrides/InfamyCardPictures/custom_cards"
		local directory = InfCrdPic_MOD:GetPath()..InfamyCardGui.CUSTOM_CARD_FOLDER_RANDOM
		
		-- All files, Selected file, file with no extension
		local files = file.GetFiles( directory )
		local file_only = files[ math.random(1,#files) ]
		
		local file_only_no_ext = file_only
		for _,ext in ipairs(InfamyCardGui.SUPPORTED_EXTENTIONS) do
			file_only_no_ext = string.gsub(file_only_no_ext, ext, "")
		end
		
		-- "custom_cards/random/FILE_NAME_HERE"
		ingame_path = InfamyCardGui.CUSTOM_CARD_FOLDER_RANDOM.."/"..file_only_no_ext
		
		-- "assets/mod_overrides/InfamyCardPictures/custom_cards/random/FILE_NAME_HERE"
		card_full_mod_path = InfCrdPic_MOD:GetPath()..InfamyCardGui.CUSTOM_CARD_FOLDER_RANDOM .."/"..file_only_no_ext
		
		card_full_mod_extension = string.gsub(file_only, file_only_no_ext, "") -- ".dds" ".tga"
	
	------------------------------------------------
	
	else -- PICK CARD FROM RANK LEVEL
		
		-- "infamy_..1"
		local infamy_rank = ""
		
		while rank > 0 do
			-- "assets/mod_overrides/InfamyCardPictures/custom_cards/infamy_1"
			infamy_rank = InfamyCardGui.CUSTOM_CARD_PREFIX .. "_" .. tostring(rank)
			card_full_mod_path = InfCrdPic_MOD:GetPath()..InfamyCardGui.CUSTOM_CARD_FOLDER .."/"..infamy_rank
			
			-- Find first file that exists with valid extension
			for _,ext in ipairs(InfamyCardGui.SUPPORTED_EXTENTIONS) do
				local exists = FileIO:Exists(card_full_mod_path..ext)
				if exists then
					card_full_mod_extension = ext
					break
				end
			end
			
			if card_full_mod_extension ~= "" then
				break
			end
			
			-- for next loop
			rank = rank - 1
		end
		
		
		
		-- "custom_cards/infamy_1"
		ingame_path = InfamyCardGui.CUSTOM_CARD_FOLDER.."/"..infamy_rank
	end
	
	-----------------------
	
	-- EXISTS TEXTURE, LOAD
	local exists = (card_full_mod_extension ~= "") and FileIO:Exists(card_full_mod_path..card_full_mod_extension)
	if exists then
		-- log( "True path: " .. card_full_mod_path..card_full_mod_extension or "NO PATH" )
		local card_image_type = "texture"
		
		-- is movie instead
		if card_full_mod_extension == ".movie" then
			card_image_type = "movie"
			-- log( "card_image_type = movie" )
		end
		
		-- log("Adding file of "..card_image_type.." to "..ingame_path)
		BeardLib.Managers.File:AddFileWithCheck(card_image_type, ingame_path, card_full_mod_path..card_full_mod_extension)
	end
		
	-- FILE EXISTS INGAME?
	-- log( ingame_path or "NO PATH" )
	local has_card_video = BeardLib.Managers.File:Has("movie", ingame_path)
	local has_card = has_card_video or BeardLib.Managers.File:Has("texture", ingame_path)
	
	self:show_texture(
		has_card and ingame_path or "custom_cards/missing_card", {
		0,
		0,
		256,
		384
	},
	has_card_video)
	
	--------------------------
	if InfamyCardGui._SHOW_INFAMY_RANK then
		local rank_icon, icon_texture_rect = managers.experience:rank_icon_data(original_rank)
		
		local icon_color = (
			InfamyCardGui.WHITEISH_CARD_COLOR - (managers.experience:rank_icon_color(original_rank) or InfamyCardGui.WHITEISH_CARD_COLOR)
				):with_alpha(1)
		
		local tx, ty, tw, th = unpack(icon_texture_rect)

		local icon_w = 48
		local icon_h = 48
		local icon_padding_x = 10
		local icon_padding_y = 10
		
		local color_mode = "sub"
		
		-- TOP LEFT
		local left_top_icon = self._icon_gui:bitmap({
			x = icon_padding_x,
			y = icon_padding_y,
			w = icon_w,
			h = icon_h,
			texture = rank_icon,
			texture_rect = {
				tx,
				ty,
				tw,
				th
			},
			blend_mode = color_mode,
			color = icon_color
		})
		
		if not InfamyCardGui._DISABLE_GLOW then
			left_top_icon:set_render_template(Idstring("OverlayVertexColorTextured"))
		end
		
		-- BOTTOM RIGHT
		local right_bottom_icon = self._icon_gui:bitmap({
			x = self._icon_gui:w() - icon_padding_x - icon_w,
			y = self._icon_gui:h() - icon_padding_y - icon_h,
			w = icon_w,
			h = icon_h,
			texture = rank_icon,
			texture_rect = {
				tx + tw,
				ty + th,
				-tw,
				-th
			},
			blend_mode = color_mode,
			color = icon_color
		})
		
		if not InfamyCardGui._DISABLE_GLOW then
			right_bottom_icon:set_render_template(Idstring("OverlayVertexColorTextured"))
		end
	end
	
	if InfamyCardGui._SHOW_INFAMY_RANK_TEXT then
		local icon_color = (
			InfamyCardGui.WHITEISH_CARD_COLOR - (managers.experience:rank_icon_color(original_rank) or InfamyCardGui.WHITEISH_CARD_COLOR)
				):with_alpha(1)
		
		local font = tweak_data.menu.pd2_massive_font
		local font_size = tweak_data.menu.pd2_massive_font_size * 1.5
		local rank_string = managers.experience:rank_string(original_rank, managers.user:get_setting("infamy_roman_card")) or ""
		local rank_text = self._text_gui:text({
			vertical = "center",
			align = "center",
			blend_mode = "sub",
			layer = 1,
			font = font,
			font_size = font_size,
			text = rank_string,
			color = icon_color
		})

		ExtendedPanel.make_fine_text(rank_text)

		local needed_width = self._text_gui:w() - 30
		local width = rank_text:w()

		rank_text:set_width(needed_width)
		rank_text:set_center(self._text_gui:w() * 0.5 + 1, self._text_gui:h() * 0.525 + 1)
		
		if not InfamyCardGui._DISABLE_GLOW then
			rank_text:set_render_template(Idstring("OverlayVertexColorTextured"))
		end
		

		local scaled_font_size = math.floor(font_size * math.min(needed_width / width, 1))

		rank_text:set_font_size(scaled_font_size)
	end
end

function InfamyCardGui:show_texture(texture, texture_rect, texture_is_movie)
	self:clear_gui()
	
	local custom_blend_mode = "normal"
	
	self._data = {
		texture = texture,
		texture_rect = texture_rect,
		texture_is_movie = texture_is_movie
	}

	if self._unit:damage() then
		self._unit:damage():run_sequence_simple("enable_card_blank")
	end
	
	----------
	
	local icon
	if texture_is_movie then
		icon = self._icon_gui:video({
			blend_mode = custom_blend_mode,
			w = self._icon_gui:w(),
			h = self._icon_gui:h(),
			video = texture,
			loop = true
		})
	else
		icon = self._icon_gui:bitmap({
			blend_mode = custom_blend_mode,
			w = self._icon_gui:w(),
			h = self._icon_gui:h(),
			texture = texture,
			texture_rect = texture_rect
		})
	end
	
	if not InfamyCardGui._DISABLE_GLOW then
		icon:set_render_template(Idstring("OverlayVertexColorTextured"))
	end
	icon:set_center(self._icon_gui:w() / 2, self._icon_gui:h() / 2)

end

function InfamyCardGui:refresh_gui(override_data)
	if not self._data then
		return
	end

	if override_data then
		self._data = override_data
	end

	if self._data.rank then
		self:show_rank(self._data.rank)
	elseif self._data.texture then
		self:show_texture(
			self._data.texture,
			self._data.texture_rect,
			self._data.texture_is_movie or false
		)
	end
end

function InfamyCardGui:add_workspace(gui_object)
	local gui_size = 256
	local x_size = 6
	local x_offset = x_size / 2
	local y_size = 9
	local y_offset = y_size / 2
	local depth_offset = 0.3
	
	local gui_width = gui_size
	local gui_height = gui_size * 1.5
	
	local suit_height = gui_size * 1.5
	local text_height = gui_size * 1.5
	self._icon_ws = self._new_gui:create_linked_workspace(gui_width, gui_height, gui_object, Vector3(x_offset, depth_offset, y_offset), Vector3(-x_size, 0, 0), Vector3(0, 0, -y_size))
	self._icon_gui = ExtendedPanel:new(self._icon_ws:panel())
	self._text_ws = self._new_gui:create_linked_workspace(gui_width, gui_height, gui_object, Vector3(x_offset, depth_offset, y_offset), Vector3(-x_size, 0, 0), Vector3(0, 0, -y_size))
	self._text_gui = ExtendedPanel:new(self._text_ws:panel())
end